%s LD LRP LRRE LRRE1 LRA LRAAD LRAAR LRAAR1 LRAAD1 LUS MUI 
 
%{
/* $Id: agc3.L 2625 2022-08-02 02:07:14Z teshields $ */ 
 
/* The information in this file is the intellectual property of 
 * Kurt M. Bischoff.  It may not be used, copied, or transferred 
 * without permission from the author. 
 *
 * Copyright (c) 1992, Kurt M. Bischoff.  All rights reserved.
 *
 * Beta Test Release--not for general distribution.
 */ 

#include <stdio.h>
#if defined(FLEX_SCANNER) || defined(REFLEX_VERSION)
static char yy3tchar,yy3sbuf[BUFSIZ]={0},*yy3sptr=&yy3sbuf[0];
#endif
extern int inFromMac;
extern char inputFromMacro();

#ifdef FLEX_SCANNER
#define YY_INPUT(buf,result,max_size) \
         {  \
         int c = myinput(); \
         result = (c == EOF) ? YY_NULL : (buf[0] = c, 1); \
         }
#define myinput() (inFromMac?((yy3sptr>yy3sbuf)?(*--yy3sptr):\
                                              inputFromMacro()\
                           ):\
                           getc(yy3in)\
                )
#undef unput
#define unput(c) {if (inFromMac) \
                     {yy3tchar= (c);*yy3sptr++=yy3tchar;} \
                     else \
                     yyunput(c, (yytext_ptr)); \
                 }
#endif

#if defined(FLEX_SCANNER) || !defined(REFLEX_VERSION)
/* AT&T Lex or flex */
#define myunput unput
#endif

#ifdef REFLEX_VERSION
#define myinput() (inFromMac?((yy3sptr>yy3sbuf)?(*--yy3sptr):\
                                              inputFromMacro()\
                           ):\
                           YY3_SCANNER.input()\
                )
#define myunput(c) {if (inFromMac) \
                       {yy3tchar= (c);*yy3sptr++=yy3tchar;} \
                       else \
                       YY3_SCANNER.unput(c); \
                   }
#endif

#if defined(REFLEX_VERSION)
#define yyout yy3out
#define YY_SCANNER YY3_SCANNER
#endif

#include <stdlib.h>
 
#include "glob.h" 
#include "opts.h" 
#include "scan.h" 
#include "YYLENG_INT.h" 
int retObjectSeen; 
#define dangRet "dangerous form of return of token.\n" 
int nLparMac; 
static int yyStartCondTemp; 
FILE *tempForTrash;
extern void initLDG(void);
extern void macroInterpSetup2(char *,char *);
extern void putCharInMacroActParam(char c);
extern void terminateActualParam();
extern void installLeafRefCountInitList(void);
extern int gSymLookup(char *);
extern void putSymbolInProdBuffer2(int);
extern int macroInterpSetup1IfMacro(char *);
%}
 
 
WS		[ \t\f]+
OPTWS		[ \t\f]*
NON_WS		[^ \t\f\n]

CHAR_CONST      ('([^\\'\n]|(\\([ntvbrfa\\?'"]|([0-7]{1,3}))))')    
DOT_NAME        ([a-zA-Z_][a-zA-Z_0-9.]*) 

GS (('([^\\'\n]|(\\([ntvbrfa\\?'"]|([0-7]{1,3}))))')|([a-zA-Z_][a-zA-Z_0-9.]*)) 
ATTRB_NAME (('([^\\'\n]|(\\([ntvbrfa\\?'"]|([0-7]{1,3}))))')?([a-zA-Z_0-9.]+)) 
 
IDENT ([a-zA-Z][a-zA-Z0-9]*)
%%
<LD,LRP,LRRE,LRRE1,LRA,LRAAD,LRAAR,LRAAR1,LRAAD1,LUS,MUI>\x19 {
			scanInit3(); return(EOSF);
		       }
<LD>(\%\%)(.*)         {BEGIN LRP; 
                        if (!buildHeaderFile) 
                           {fprintf(Lfile[currentLfile].outPtr,"\n%%{\n"); 
                            appendToOutFile(yoxOutH,yoxOutFileStrH,
                                            Lfile[currentLfile].outPtr
                                           ); 
                            fprintf(Lfile[currentLfile].outPtr,"\n%%}\n"); 
                           } 
                        stringOut(yy3text,outL); 
                        return(MARK);
                       }  
<LD>\n|.               charOut(*yy3text,outL);    
<LRP>.*\n/{NON_WS}     {stringOut(yy3text,outL); BEGIN LRRE; nLbraces = 0;}  
<LRP>.*\n              stringOut(yy3text,outL);  
<LRRE>^\%\%.*\n        {BEGIN LUS; stringOut(yy3text,outL); return(MARK2); }  
<LRRE>{WS}\%\{         {stringOut(yy3text,outL); BEGIN LRRE1; line = yy3lineno;}   
<LRRE>{OPTWS}\n        stringOut(yy3text,outL);  
<LRRE1>\%\}.*          {stringOut(yy3text,outL); BEGIN LRRE;}   
<LRRE1>\/\*            eatCommentAndEcho(outL,1); 
<LRRE1>\"              eatStringAndEcho(outL); 
<LRRE1>{CHAR_CONST}    stringOut(yy3text,outL);  
<LRRE1>\n              charOut('\n',outL);   
<LRRE1>.               charOut(*yy3text,outL);   
<LRRE>{WS}\|.*\n       stringOut(yy3text,outL);   
<LRRE>{WS}             {stringOut(yy3text,outL); BEGIN LRA; line = yy3lineno;}  
<LRRE>^{OPTWS}"/*"     {stringOut(yy3text,outL); /* descendant of the culprit */  
                        eatCommentAndEcho(outL,0); 
                       }
<LRRE>"["([^\\\]\n]|(\\([ntvbrfa\\?]|([0-7]{1,3}))))+"]" stringOut(yy3text,outL); 
<LRRE>.                charOut(*yy3text,outL);     
<LRA>\/\*              eatCommentAndEcho(outL,1); /* doesn't work with berkeley */
<LRA>\"                eatStringAndEcho(outL); 
<LRA>{CHAR_CONST}      stringOut(yy3text,outL);  
<LRA>\{                {charOut('{',outL); nLbraces++;}
<LRA>\}                {charOut('}',outL); nLbraces--;} 
<LRA>.                 charOut(*yy3text,outL);   
<LRA>\n                {charOut('\n',outL); if (nLbraces == 0) BEGIN LRRE;} 
<LRA>return            {charOut('{',outL); 
                        stringOut(yy3text,LA1); 
                        retObjectSeen = 0; 
                        nLparens = 0; 
                        BEGIN LRAAR; 
                        return(RETURN);
                       } 
<LRAAR>\/\*            eatCommentAndEcho(LA1,1); 
<LRAAR>\"              eatStringAndEcho(LA1); 
<LRAAR>{WS}            stringOut(yy3text,LA1); 
<LRAAR>\(              {charOut('(',LA1); nLparens++;} 
<LRAAR>\)              {charOut(')',LA1); 
                        if ((--nLparens) < 0) yerror("unmatched \')\'\n"); 
                       } 
<LRAAR>{GS}            {int symTabInd; 
                        
                        stringOut(yy3text,LA1); 
                        if (yy3text[0] == '\'') 
                           {if (retObjectSeen) ywarning(dangRet);
                               else 
                               {retObjectSeen = 1; 
                                IDbuffer = stringLookup(yy3text,yy3leng,1);  
                                return(ID); 
                               }
                           } 
                        else if ((IDbuffer = stringLookup(yy3text,yy3leng,0)) 
                                 == 
                                 ((char *)NULL)
                                )
                           ;
                        else if ((symTabInd = gSymLookup(IDbuffer)) == -1) 
                           ;
                        else if (gSymTable[symTabInd].symNum < 0)  
                           {yerror("to return nonterminal");
                            fprintf(stderr," %s as token.\n",IDbuffer);
                            if (!retObjectSeen) 
                               {retObjectSeen = 1; 
                                return(ID); 
                               }
                           }
                        else if (gSymTable[symTabInd].symNum == 0)  
                           {ywarning("to return attributed symbol");
                            fprintf(stderr," %s\n  not declared by %%token.\n",
                                    IDbuffer
                                   );
                            if (!retObjectSeen) 
                               {retObjectSeen = 1; 
                                return(ID); 
                               }
                           }
                        else
                           {if (retObjectSeen) 
                               ywarning(dangRet);
                               else
                               {retObjectSeen = 1; 
                                return(ID); 
                               }
                           } 
                       } 
<LRAAR>\n              {if (nLbraces == 0) 
                           {yerror("return statement broken by line feed\n"); 
                            myunput(*yy3text); 
                            BEGIN LRA;  
                           } 
                           else  
                           charOut('\n',LA1); 
                       } 
<LRAAR>;               {charOut(';',LA1); 
                        BEGIN LRAAR1; 
                        if (!retObjectSeen) ywarning(dangRet); 
                        if (!nLparens) 
                           {charOut('}',LA1); 
                            return(';'); 
                           } 
                       } 
<LRAAR>.               charOut(*yy3text,LA1); 
<LRAAR1>\/\*           eatCommentAndEcho(LA1,1); 
<LRAAR1>{WS}           stringOut(yy3text,LA1); 
<LRAAR1>@\{            {BEGIN LRAAD; 
                        if (neutralizeSemActions) 
                           {tempForTrash = Lfile[currentLfile].outPtr;  
                            Lfile[currentLfile].outPtr = tempTrashOut;  
                           }
                        return(LBRACE);
                       }   
<LRAAR1>\n             {if (nLbraces == 0) 
                          {if (!prodBufferPointer2) /* last chance */  
                             {fprintf(stderr, 
                                "  unknown node type--assuming no attributes.\n"
                                      );
                              putSymbolInProdBuffer2(gSymLookup(dumNodeSym)); 
                              installLeafRefCountInitList();  
                              initLDG();
                             } 
                           flushLAbuffer(LA1,outL); 
                           myunput(*yy3text); 
                           BEGIN LRA;  
                          } 
                          else  
                          charOut('\n',LA1); 
                       } 
<LRAAR1>.              {if (!prodBufferPointer2) /* last chance */  
                          {ywarning(
                             "unknown node type--assuming no attributes.\n"
                                   );
                           putSymbolInProdBuffer2(gSymLookup(dumNodeSym)); 
                           installLeafRefCountInitList();  
                           initLDG();
                          } 
                        flushLAbuffer(LA1,outL); 
                        myunput(*yy3text); 
                        BEGIN LRA;  
                       } 
<LRAAD>\/\*            eatCommentAndEcho(outL,1); 
<LRAAD>\"              eatStringAndEcho(outL); 
<LRAAD>{CHAR_CONST}    stringOut(yy3text,outL); 
<LRAAD>{IDENT}         {IDbuffer = stringLookup(yy3text,yy3leng,1);
                        if (macroInterpSetup1IfMacro(IDbuffer)) 
                           {nLparMac = 0; 
                            BEGIN MUI; 
                            yyStartCondTemp = LRAAD; 
                           }
                           else 
                           stringOut(yy3text,outL); 
                       }   
<LRAAD>{WS}            stringOut(yy3text,outL); 
<LRAAD>@\}             {if (!prodBufferPointer2) /* last chance */  
                          {ywarning(
                             "unknown node type--assuming no attributes.\n"
                                   );
                           putSymbolInProdBuffer2(gSymLookup(dumNodeSym)); 
                           installLeafRefCountInitList();  
                           initLDG();
                          } 
                        if (neutralizeSemActions) 
                           fprintf(Lfile[currentLfile].outPtr," */ ");  
                        if (neutralizeSemActions) 
                            Lfile[currentLfile].outPtr = tempForTrash;  
                        flushLAbuffer(LA1,outL); 
                        BEGIN LRA;
                        return(RBRACE);
                       }   
<LRAAD>@               BEGIN LRAAD1; 
<LRAAD>\n|.            charOut(*yy3text,outL); 
<LRAAD1>@              BEGIN LRAAD; 
<LRAAD1>{ATTRB_NAME}   {scanAttrbName(yy3text,yy3leng); 
                        transAttrbNameToNumPair(); 
                        return(ID); 
                       }     
<LRAAD1>.              {myunput(*yy3text); 
                        yerror("attribute reference not terminated by @.\n"); 
	                BEGIN LRA;
		       } 
<MUI>\(                {if (++nLparMac != 1) 
                           yerror("unbalanced parentheses in macro use.\n");
                       }
<MUI>\)                {if (--nLparMac != 0) 
                           yerror("unbalanced parentheses in macro use.\n");
                           else 
                           {macroInterpSetup2(yy3sbuf,yy3sptr); 
                            BEGIN yyStartCondTemp;
                           }
                       }
<MUI>[,]               terminateActualParam(); 
<MUI>\\\\              putCharInMacroActParam('\\');  
<MUI>\\[,]             putCharInMacroActParam(',');  
<MUI>\\\(              putCharInMacroActParam('(');  
<MUI>\\\)              putCharInMacroActParam(')');  
<MUI>\\           yerror("misuse of \'\\\' escape character in macro use.\n"); 
<MUI>.|\n              putCharInMacroActParam(*yy3text);  
<LUS>\n|.              charOut(*yy3text,outL);   
%%   
#ifdef REFLEX_VERSION
#undef yy3text
#undef yy3leng
#undef yy3lineno
#endif

void scanInit3(void) 
  {whichScanner = 3; 
   yy3lineno = 1; 
   plineno = &yy3lineno; 
#ifndef REFLEX_VERSION
   ptext = yy3text; 
   pleng = &yy3leng; 
#endif
#if defined(FLEX_SCANNER) || defined(REFLEX_VERSION)
   yyrestart(Lfile[currentLfile].inPtr);
#endif
   yy3in = Lfile[currentLfile].inPtr; 
#ifdef REFLEX_VERSION
   YY3_SCANNER.start(LD);
#else
   BEGIN LD;
#endif
   inFileStr = Lfile[currentLfile].inName; 
  } 


int yy3ScnState(void) {return YYSTATE;} 



int yy3wrap(void) 
  {if (eatCom) {yerror("error: unterminated comment.\n");
                fprintf(stderr, "comment began at line %5d\n",line);  
                goto err1;  
               } 
   if (eatStr) {yerror("error: unterminated string.\n");
                fprintf(stderr,"string began at line %5d\n",line);  
                goto err1;  
               } 
   if (yy3ScnState() == LRRE1) 
      {yerror("error: unterminated lex code section.\n");
       fprintf(stderr, "section began at line %5d\n",line ); 
       goto err1;  
      } 
   if (yy3ScnState() == LRA) 
      {yerror("error: unterminated lex action.\n");   
       fprintf(stderr,"action began at line %5d\n",line);  
       goto err1; 
      }  
   if (yy3ScnState() == LRAAR) 
      yerror("error: identifier expected after \"return\".\n");   
   currentLfile++; 
   if (currentLfile == nLfiles) 
      return(1);  
      else 
      {
#if defined(FLEX_SCANNER) || defined(REFLEX_VERSION)
       yy_scan_string("\x19");
#else
       /* AT&T Lex */
       unput('\x19');
#endif
       return(0);  
      }
err1:
   rmTempFiles();
   exit(-1);
  } 


/* LD LRP LRRE LRRE1 LRA LRAAR LRAAR1 LRAAD LRAAD1 LUS are start 
 * conditions of the scanner 
 * that pertain to scanning and parsing the lexical specification (which 
 * is written in a lex-like syntax).  The main problem is for the scanner 
 * to know when it is looking at a lex action, and to look for 
 * at signs inside such actions, and to ignore at signs elsewhere.   
 *  
 * LD is for echoing the lex definitions section.  
 * 
 * LRP is for echoing the prolog of the lex rules section.   
 * 
 * LRRE is for echoing and detecting the ends of lex regular expressions. 
 * lex r.e.'s are terminated and lex actions are initiated by whitespace.  
 *
 * LRRE1 is for echoing C code sections, indented and delimited by "%{" and 
 * "%}".   
 * 
 * LRA is for looking for attribute references inside of actions in the lex 
 * rules section, and for looking for the ends of such actions.  A lex action 
 * is terminated by the first newline outside of properly paired curly 
 * braces. 
 * 
 * LRAAR is for finding the name of the first grammar symbol seen   
 * after the "return" reserved word in a lex action.  Everything from the
 * return up to its terminating semicolon is put in a lookahead buffer 
 * along with a closing curly brace until the attributes definition section 
 * (if any) is processed.  The semicolon sends this scanner into LRAAR1.   
 * 
 * In LRAAR1, a newline outside of curly braces or anything else  
 * except whitespace and comments means that no attribute definition 
 * section follows the return, and the lookahead buffer (which contains 
 * the return and its object) is flushed.  @{ causes a change to LRAAD.   
 *  
 * LUS is for echoing the optional user subroutines section found after 
 * the second "%%" in the lexical specification.   
 *
*/ 

/* Lexemes suitable for grammar symbols are 1)identifiers previously declared
 * as tokens, or 2)character constants. 
 *
 * If exactly one lexeme suitable for a grammar symbol appears between 
 * return and ; a node of that type will be put on the tree just before 
 * each time said return is executed.  
 *
 * If no such lexeme appears there, a warning is issued.  If there is not a 
 * non-empty attribute definition section, the type of the dummy node symbol 
 * is used and another warning is issued.  
 * 
 * If more than one suitable lexeme appears, the first such is assumed for the
 * node type, and subsequent ones generate a warning.    
 */ 

#if defined(FLEX_SCANNER) || defined(REFLEX_VERSION)
int yy3input(void) {return myinput();}
#endif
