%{
#include "parser.h" 
#include "pt.h" 
%}

%%  
[ \t\f]*                   ;  
[0-9]+                     return(CONST); @{ 
                                       sscanf(yytext,"%d",&(@CONST.val@)); 
                                          @}   
\(                         return('('); 
\)                         return(')'); 
\+                         return('+'); 
\*                         return('*'); 
\n                         return('\n'); 
.                          fprintf(stderr,"illegal character\n"); 
%%
int yywrap(void){return 1;}

