case 1:
YY_RULE_SETUP
{ count(); /* ignore whitespace */ }
	YY_BREAK
case 2:
/* rule 2 can match eol */
YY_RULE_SETUP
{ linenumber++; columnnumber = 0; }
	YY_BREAK
case 3:
YY_RULE_SETUP
{ comment(); }
	YY_BREAK
case 4:
YY_RULE_SETUP
{ count(); return TK_INT; }
	YY_BREAK
case 5:
YY_RULE_SETUP
{ count(); return TK_EXTERN; }
	YY_BREAK
case 6:
YY_RULE_SETUP
{ count(); return TK_STRUCT; }
	YY_BREAK
case 7:
YY_RULE_SETUP
{ count(); return TK_IF; }
	YY_BREAK
case 8:
YY_RULE_SETUP
{ count(); return TK_ELSE; }
	YY_BREAK
case 9:
YY_RULE_SETUP
{ count(); return TK_FOR; }
	YY_BREAK
case 10:
YY_RULE_SETUP
{ count(); return TK_DO; }
	YY_BREAK
case 11:
YY_RULE_SETUP
{ count(); return TK_WHILE; }
	YY_BREAK
case 12:
YY_RULE_SETUP
{ count(); return TK_SIZEOF; }
	YY_BREAK
case 13:
YY_RULE_SETUP
{ count(); return TK_BREAK; }
	YY_BREAK
case 14:
YY_RULE_SETUP
{ count(); return TK_RETURN; }
	YY_BREAK
case 15:
YY_RULE_SETUP
{ count(); id(); return TK_IDENTIFIER; }
	YY_BREAK
case 16:
YY_RULE_SETUP
{ count(); dec_constant(); return TK_ICONSTANT;
  @{ @TK_ICONSTANT.val@ = yylval.i; @}
}
	YY_BREAK
case 17:
YY_RULE_SETUP
{ count(); hex_constant(); return TK_ICONSTANT;
  @{ @TK_ICONSTANT.val@ = yylval.i; @}
}
	YY_BREAK
case 18:
YY_RULE_SETUP
{ count(); oct_constant(); return TK_ICONSTANT;
  @{ @TK_ICONSTANT.val@ = yylval.i; @}
}
	YY_BREAK
case 19:
YY_RULE_SETUP
{ count(); return TK_INC; }
	YY_BREAK
case 20:
YY_RULE_SETUP
{ count(); return TK_DEC; }
	YY_BREAK
case 21:
YY_RULE_SETUP
{ count(); return TK_PTR; }
	YY_BREAK
case 22:
YY_RULE_SETUP
{ count(); return TK_OR; }
	YY_BREAK
case 23:
YY_RULE_SETUP
{ count(); return TK_LE; }
	YY_BREAK
case 24:
YY_RULE_SETUP
{ count(); return TK_GE; }
	YY_BREAK
case 25:
YY_RULE_SETUP
{ count(); return TK_EQ; }
	YY_BREAK
case 26:
YY_RULE_SETUP
{ count(); return TK_NE; }
	YY_BREAK
case 27:
YY_RULE_SETUP
{ count(); return TK_AND; }
	YY_BREAK
case 28:
YY_RULE_SETUP
{ count(); return('.'); }
	YY_BREAK
case 29:
YY_RULE_SETUP
{ count(); return(','); }
	YY_BREAK
case 30:
YY_RULE_SETUP
{ count(); return(';'); }
	YY_BREAK
case 31:
YY_RULE_SETUP
{ count(); return('{'); }
	YY_BREAK
case 32:
YY_RULE_SETUP
{ count(); return('}'); }
	YY_BREAK
case 33:
YY_RULE_SETUP
{ count(); return('('); }
	YY_BREAK
case 34:
YY_RULE_SETUP
{ count(); return(')'); }
	YY_BREAK
case 35:
YY_RULE_SETUP
{ count(); return('['); }
	YY_BREAK
case 36:
YY_RULE_SETUP
{ count(); return(']'); }
	YY_BREAK
case 37:
YY_RULE_SETUP
{ count(); return('&'); }
	YY_BREAK
case 38:
YY_RULE_SETUP
{ count(); return('!'); }
	YY_BREAK
case 39:
YY_RULE_SETUP
{ count(); return('='); }
	YY_BREAK
case 40:
YY_RULE_SETUP
{ count(); return('-'); }
	YY_BREAK
case 41:
YY_RULE_SETUP
{ count(); return('+'); }
	YY_BREAK
case 42:
YY_RULE_SETUP
{ count(); return('*'); }
	YY_BREAK
case 43:
YY_RULE_SETUP
{ count(); return('/'); }
	YY_BREAK
case 44:
YY_RULE_SETUP
{ count(); return('%'); }
	YY_BREAK
case 45:
YY_RULE_SETUP
{ count(); return('<'); }
	YY_BREAK
case 46:
YY_RULE_SETUP
{ count(); return('>'); }
	YY_BREAK
case 47:
YY_RULE_SETUP
{ /* sop up any other characters */ error("unknown character 0%o (%c), yytext[0], yytext[0]); }
	YY_BREAK
