/*
  tiny - C
*/

/* types of identifiers */
%token TK_IDENTIFIER

/* types of constants */
%token TK_ICONSTANT

/* simple operators */
%token TK_PTR TK_INC TK_DEC TK_LE TK_GE TK_EQ TK_NE
%token TK_AND TK_OR TK_DOT


/* keywords */
%token TK_EXTERN 
%token TK_INT 
%token TK_STRUCT
%token TK_IF TK_ELSE TK_WHILE TK_DO TK_FOR TK_RETURN TK_BREAK TK_SIZEOF

/* This declares the attribute stack entry */
%union {
	double			d;
	int			i;
	char		       *s;
	struct typestruct      *t;
	unsigned int		u;
	struct sym             *y;
	struct node            *n;
