%{
#if defined (__cplusplus)
#include <cstdlib>
#include <cstring>
#else
#include <stdlib.h>
#include <string.h>
#endif

#include "parser.h"

#define lexeme strcpy((char *)malloc(yyleng+1),yytext)
%}

%% 
[ \n\t\f]+        ;  
real              return(REAL);
integer           return(INT);
boolean           return(BOOL);
[a-zA-Z]+         return(IDENT);  @{ @IDENT.string@ = lexeme; @} 
","               return(',');
";"               return(';');
":"               return(':');
.                 {fprintf(stderr,"illegal character\n"); exit(-1);} 
%%
int yywrap(void){return 1;}
