%s YD YDSI YR YR1 ADECL LVA ADSL AA LAAA LAAA1 UU CC 
%s DL CL CL1 CL2 TT RR RR1 
%s EOGFRET   
%s LD LKLDG LRP LRRE LRRE1 LRA LRAAD LRAAR LRAAD1 LUS 
 
 
%{
/* $Id: agc.L 2544 2022-05-23 00:41:27Z teshields $ */ 
/* RCS Log:	agc.l,v
 * Revision 9.3  91/04/19  08:28:39  08:28:39  bischoff (Kurt Bischoff)
 * *** empty log message ***
 * 
 * Revision 9.2  91/04/19  08:02:36  08:02:36  bischoff (Kurt Bischoff)
 * *** empty log message ***
 * 
 * Revision 9.1  91/04/13  03:15:54  03:15:54  bischoff (Kurt Bischoff)
 * *** empty log message ***
 * 
 * Revision 8.5  91/04/12  03:08:57  03:08:57  bischoff (Kurt Bischoff)
 * *** empty log message ***
 * 
 * Revision 8.1  91/04/10  09:50:02  09:50:02  bischoff (Kurt Bischoff)
 * *** empty log message ***
 * 
 * Revision 7.4  91/04/10  03:20:38  03:20:38  bischoff (Kurt Bischoff)
 * *** empty log message ***
 * 
 * Revision 7.3  91/04/05  19:18:57  19:18:57  bischoff (Kurt Bischoff)
 * *** empty log message ***
 * 
 * Revision 7.2  90/09/23  05:32:53  05:32:53  bischoff (Kurt Bischoff)
 * Changed the 'pet' symbol of yox from '$' to '@'
 * 
 */
  
#include "parser.h" 
#include "globalDecls.h" 
#include "scan.h" 
%}
 
 
WS		[ \t\f]+
OPTWS		[ \t\f]*
NON_WS		[^ \t\f\n]

CHAR_CONST      ('([^\\'\n]|(\\([ntvbrfa\\?'"]|([0-7]{1,3}))))')    
DOT_NAME        ([a-zA-Z_][a-zA-Z_0-9.]*) 

GS (('([^\\'\n]|(\\([ntvbrfa\\?'"]|([0-7]{1,3}))))')|([a-zA-Z_][a-zA-Z_0-9.]*)) 
ATTRB_NAME (('([^\\'\n]|(\\([ntvbrfa\\?'"]|([0-7]{1,3}))))')?([a-zA-Z_0-9.]+)) 
 
/* the following are needed by AT&T Lex  */
/* fortunately, they are ignored by flex */
%e 2500 
%p 5500 
%n 800 
%k 1400 
%a 5000 
%o 5000 

%%
<YD>[ \t\n\f]          charOut(*yytext,outG);          
<YD>\/\*               eatCommentAndEcho(outG);
<YD>{CHAR_CONST}       {lexemeOut(outG); 
                        IDbuffer = stringLookup(yytext,yyleng,1); 
                        return(ID); 
                       };  
<YD>{DOT_NAME}         {lexemeOut(outG); 
                        IDbuffer = stringLookup(yytext,yyleng,1); 
                        return(ID); 
                       };  
<YD>[0-9]+             {lexemeOut(outG); return(NUM);}; 
<YD>\%left             {lexemeOut(outG); return(LEFT);}; 
<YD>\%right            {lexemeOut(outG); return(RIGHT);}; 
<YD>\%nonassoc         {lexemeOut(outG); return(NONASSOC);}; 
<YD>\%token            {lexemeOut(outG); return(TOKEN);}; 
<YD>\%type             {lexemeOut(outG); return(TYPE);}; 
<YD>\%start            {lexemeOut(outG); BEGIN YDSI; return(START);};  
<YDSI>[ \t\n\f]        charOut(*yytext,outG);           
<YDSI>\/\*             eatCommentAndEcho(outG);
<YDSI>{DOT_NAME}       {startSymLexeme = stringLookup(yytext,yyleng,1); 
                        fprintf(yoxOutG,"%s",augNstr); 
                        BEGIN YD; 
                        return(ID);  
                       };  
<YD>\%union            {lexemeOut(outG); nLbraces = 0;
                        BEGIN UU; return(UNION); 
                       };
<YD>@attributes        {BEGIN ADECL; return(ATTRIBUTES);}; 
<YD>\%\%               {afterAllAttrbDecls();   
                        lexemeOut(outG); 
			BEGIN YR; 
                        return(MARK); 
                       }; 
<YD>\%\{               {lexemeOut(outG); return(LCURL);}; 
<YD>\<                 {charOut('<',outG); return('<');};   
<YD>\>                 {charOut('>',outG); return('>');};   
<YD>[,]                {charOut(',',outG); return(',');};   
<YD>\{                 {charOut('{',outG); return('{');};   
<YD>.                  {charOut(*yytext,outG); yyerror("syntax error 1.\n");};
<UU>\{                 {charOut('{',outG); nLbraces++;};   
<UU>\}                 {charOut('}',outG); if (!(--nLbraces)) BEGIN YD;}; 
<UU>\/\*               eatCommentAndEcho(outG); 
<UU>\"                 eatStringAndEcho(outG); 
<UU>\\\"               lexemeOut(outG);  
<UU>\n                 charOut('\n',outG);    
<UU>.                  charOut(*yytext,outG);    
<CC>\%\}               {lexemeOut(outG); BEGIN YD;};    
<CC>\\\/               lexemeOut(outG);  
<CC>\"                 eatStringAndEcho(outG); 
<CC>\\\"               lexemeOut(outG);  
<CC>\/\*               eatCommentAndEcho(outG);  
<CC>\n                 charOut('\n',outG);    
<CC>.                  charOut(*yytext,outG);    
<ADECL>[ \t\n\f]       charOut(*yytext,outGandL);          
<ADECL>\/\*            eatCommentAndEcho(outGandL);
<ADECL>\{              {charOut('{',outGandL); return('{');};   
<ADECL>\}              {charOut('}',outGandL); BEGIN ADSL; return('}');};   
<ADECL>@void           {BEGIN LVA; return(VOID);}; 
<LVA>{DOT_NAME}        {IDbuffer = stringLookup(yytext,yyleng,1); return(ID);} 
<LVA>[ \t\n\f]         charOut(*yytext,outGandL);  
<LVA>\/\*              eatCommentAndEcho(outGandL); 
<LVA>[,]               return(','); 
<LVA>;                 {BEGIN ADECL; return(';');};  
<ADECL>struct          {lexemeOut(outGandL); return(STRUCT);};  
<ADECL>union           {lexemeOut(outGandL); return(UNIONC);};  
<ADECL>char            {lexemeOut(outGandL); return(CHAR);};  
<ADECL>short           {lexemeOut(outGandL); return(SHORT);};  
<ADECL>int             {lexemeOut(outGandL); return(INT);};  
<ADECL>long            {lexemeOut(outGandL); return(LONG);};  
<ADECL>float           {lexemeOut(outGandL); return(FLOAT);};  
<ADECL>double          {lexemeOut(outGandL); return(DOUBLE);};  
<ADECL>signed          {lexemeOut(outGandL); return(SIGNED);};  
<ADECL>unsigned        {lexemeOut(outGandL); return(UNSIGNED);};  
<ADECL>{DOT_NAME}      {IDbuffer = stringLookup(yytext,yyleng,1); 
		        lexemeOut(outGandL); 
                        return(ID);  
		       };  
<ADECL>[,]             {charOut(',',outGandL); return(',');};   
<ADECL>:               {charOut(':',outGandL); return(':');};   
<ADECL>[0-9]+          {lexemeOut(outGandL); return(NUM);}; 
<ADECL>;               {charOut(';',outGandL); return(';');};   
<ADECL>\*              {charOut('*',outGandL); return('*');};   
<ADECL>.               {charOut(*yytext,outGandL); 
                        yyerror("syntax error AD.\n");
                       };
<ADSL>{GS}             {IDbuffer = stringLookup(yytext,yyleng,1); 
                        return(ID);   
                       };
<ADSL>[ \t\n\f]        charOut(*yytext,outG);   
<ADSL>\/\*             eatCommentAndEcho(outG);
<ADSL>.                {unput(*yytext); BEGIN YD;};   
<YR>[ \t\n\f]          {flushLAbuffer(LA1,outG); charOut(*yytext,outG);};  
<YR>\/\*               {flushLAbuffer(LA1,outG); eatCommentAndEcho(outG);};
<YR>{CHAR_CONST}       {flushLAbuffer(LA1,outG); lexemeOut(outG);
                        IDbuffer = stringLookup(yytext,yyleng,1); 
                        return(ID); 
                       };  
<YR>{DOT_NAME}         {IDbuffer = stringLookup(yytext,yyleng,1); 
		        lexemeOut(LA1); 
		        BEGIN YR1;
		       };  
<YR1>[ \t\n\f]         charOut(*yytext,LA1);  
<YR1>\/\*              eatCommentAndEcho(LA1);
<YR1>:                 {charOut(':',LA1); 
                        if (!alreadyAugmented) 
                           {printAugmentationProduction(); 
                            flushLAbuffer(LA1,outG); 
                           } 
                        BEGIN YR; 
                        return(IDCOLON); 
                       };    
<YR1>.                 {flushLAbuffer(LA1,outG);  
                        unput(*yytext); BEGIN YR; return(ID); 
                       };   
<YR>\%prec             {flushLAbuffer(LA1,outG); lexemeOut(outG); 
                        return(PREC); 
                       }; 
<YR>\%\%               {charOut('\n',LA1); 
                        lexemeOut(LA1); 
                        return(MARK); 
                       }; 
<YR>\|                 {charOut('|',LA1); return('|'); 
                       };   
<YR>\{                 {flushLAbuffer(LA1,outG); charOut('{',outG); 
                        return('{'); 
		       };   
<YR>;                  {charOut(';',LA1); 
                        return(';'); 
                       };   
<YR>@@                 {BEGIN RR; return(ATAT);}; 
<YR>@\{                {BEGIN DL; line = yylineno; return(LBRACE);};
<YR>.                  {charOut(*yytext,outG); yyerror("syntax error 1.\n");};
<AA>\{                 {charOut('{',outG); nLbraces++;};   
<AA>\}                 {nLbraces--; 
			if (nLbraces == 0) 
			   {BEGIN LAAA;
                            charOut('}',LA1);  
			    return('}');
			   } 
                           else 
			   charOut('}',outG); 
		       }; 
<AA>'\{'               lexemeOut(outG);  
<AA>'\}'               lexemeOut(outG);  
<AA>\/\*               eatCommentAndEcho(outG); 
<AA>\"                 eatStringAndEcho(outG); 
<AA>\\\"               lexemeOut(outG);   
<AA>\n                 charOut('\n',outG);    
<AA>.                  charOut(*yytext,outG);  
<LAAA>\/\*             eatCommentAndEcho(LA1);  
<LAAA>[ \n\t\f]        charOut(*yytext,LA1);  
<LAAA>{CHAR_CONST}     {IDbuffer = stringLookup(yytext,yyleng,1); 
                        flushLAbuffer(LA1,outG); lexemeOut(outG); BEGIN YR; 
                        return(ID);  
                       };  
<LAAA>{DOT_NAME}       {IDbuffer = stringLookup(yytext,yyleng,1); 
		        lexemeOut(LA1);  
		        BEGIN LAAA1;
		       };  
<LAAA1>\/\*            eatCommentAndEcho(LA1);
<LAAA1>[ \t\n\f]       charOut(*yytext,LA1);  
<LAAA1>:               {charOut(':',LA1); BEGIN YR; return(IDCOLON); 
                       };    
<LAAA1>.               {flushLAbuffer(LA1,outG); unput(*yytext); 
                        BEGIN YR; return(ID);
                       };
<LAAA>@\{              {BEGIN DL; line = yylineno; return(LBRACE);
                       };
<LAAA>@@               {BEGIN RR; return(ATAT);
                       }; 
<LAAA>\%\%             {charOut('\n',LA1); 
			lexemeOut(LA1); BEGIN TT; return(MARK); 
                       };  
<LAAA>\%prec           {flushLAbuffer(LA1,outG); 
                        lexemeOut(outG); BEGIN YR; return(PREC); 
                       };  
<LAAA>;                {charOut(';',LA1); BEGIN YR; return(';');
                       };  
<LAAA>\{               {flushLAbuffer(LA1,outG); charOut('{',outG); BEGIN AA; 
			yyerror("consecutive actions not permitted.\n"); 
			return('{'); 
                       };  
<LAAA>\|               {charOut('|',LA1); BEGIN YR; return('|'); 
                       };  
<LAAA>.                {flushLAbuffer(LA1,outG); 
			yyerror("syntax error after action.\n");
                       };  
<RR>\%\%               {lexemeOut(outG); return(MARK);};   
<RR>\/\*               eatCommentAndEcho(outT1);  
<RR>\"                 eatStringAndEcho(outT1);  
<RR>\\\"               lexemeOut(outT1);    
<RR>@                  BEGIN RR1;  
<RR>\$\$               |    
<RR>\$[0-9]+           {yyerror(
                        "yacc psuedo-variable in root reference section.\n"
                               );  
                       }; 
<RR1>@                 BEGIN RR;  
<RR1>{ATTRB_NAME}      {scanAttrbName(); transAttrbNameToNumPair();
                        return(ID); 
                       };     
<RR1>\n|.              {unput(*yytext); 
			yyerror("attribute reference not terminated by @.\n");
	                BEGIN RR;
		       };  
<RR>.|\n               charOut(*yytext,outT1);   
<DL>\/\*               eatCommentAndEcho(rsB);  
<DL>@\}                {BEGIN YR; return(RBRACE);};
<DL>[ \n\t\f]          ;   
<DL>{ATTRB_NAME}       {scanAttrbName(); transAttrbNameToNumPair(); 
                        return(ID); 
                       };     
<DL>:                  return(':');  
<DL>;                  {nLbraces = 0; BEGIN CL; 
                        return(';'); 
                       };  
<DL>::                 {nLbraces = 0; BEGIN CL; 
                        return(COLCOL); 
                       };   
<DL>:::                {nLbraces = 0; BEGIN CL; 
                        return(COLCOLCOL); 
                       };   
<DL>.                  {yyerror("syntax error in dependency line.\n");   
                        nLbraces = 1; BEGIN CL; 
                        return(';'); 
                       };  
<CL>\/\*               eatCommentAndEcho(rsB); 
<CL>\"                 eatStringAndEcho(rsB); 
<CL>\\\"               lexemeOut(rsB);    
<CL>@                  BEGIN CL1;   
<CL>\$\$               {lexemeOut(rsB); hasYaccPvarRefGlob = 1;}; 
<CL>\$[0-9]+           {lexemeOut(rsB); hasYaccPvarRefGlob = 1;}; 
<CL1>@                 BEGIN CL;  
<CL1>{ATTRB_NAME}      {scanAttrbName(); transAttrbNameToNumPair(); 
                        putAttrbNumPairInRefSegBuffer(bufPosInProd,bufAttrbNum);
                        return(ID); 
                       };     
<CL1>(\n|[^@])         {unput(*yytext); 
			yyerror(
 	"\nattribute references must be delimited by pairs of @\'s.\n"
		               ); 
	                BEGIN CL;
		       };  
<CL>\\/{OPTWS}\n       BEGIN CL2;  
<CL2>{OPTWS}\n         {lexemeOut(rsB); BEGIN CL;};  
<CL>\n                 {charOut('\n',rsB); 
                        if (nLbraces == 0) {BEGIN DL;return('\n');} 
                       }; 
<CL>@\}                {unput('}');unput('@');BEGIN DL;return('\n');} 
<CL>\{                 {charOut('{',rsB); nLbraces++;};
<CL>\}                 {charOut('}',rsB); nLbraces--;}; 
<CL>'\{'               lexemeOut(rsB);   
<CL>'\}'               lexemeOut(rsB);   
<CL>.                  charOut(*yytext,rsB);  
<TT>\n|.               charOut(*yytext,outG);    
<EOGFRET>(\%\%)(.*)    {yyless(0); BEGIN LKLDG; return(EOGF);};  
<EOGFRET>\n            {unput(*yytext); BEGIN LD; return(EOGF);};  
<EOGFRET>.             {unput(*yytext); BEGIN LD; return(EOGF);};  
<LKLDG>(\%\%)(.*)      {BEGIN LRP; lexemeOut(outL); return(MARK);};  
<LD>^(\%\%)(.*)        {BEGIN LRP; lexemeOut(outL); return(MARK);};  
<LD>\n|.               charOut(*yytext,outL);    
<LRP>.*\n/{NON_WS}     {lexemeOut(outL); BEGIN LRRE; nLbraces = 0;};  
<LRP>.*\n              lexemeOut(outL);  
<LRRE>^\%\%.*\n        {BEGIN LUS; lexemeOut(outL); return(MARK);};  
<LRRE>{WS}\%\{         {lexemeOut(outL); BEGIN LRRE1; line = yylineno;};   
<LRRE>{OPTWS}\n        lexemeOut(outL);  
<LRRE1>\%\}.*          {lexemeOut(outL); BEGIN LRRE;};   
<LRRE1>\/\*            eatCommentAndEcho(outL); 
<LRRE1>\\\/            lexemeOut(outL);  
<LRRE1>\"              eatStringAndEcho(outL); 
<LRRE1>\\\"            lexemeOut(outL);  
<LRRE1>\n              charOut('\n',outL);   
<LRRE1>.               charOut(*yytext,outL);   
<LRRE>{WS}\|.*\n       lexemeOut(outL);   
<LRRE>{WS}             {lexemeOut(outL); BEGIN LRA; line = yylineno;};  
<LRRE>(^({OPTWS}))/"/*"  lexemeOut(outL); /* the culprit */  
<LRRE>\/\*             eatCommentAndEcho(outL); 
<LRRE>^{WS}([^/\n]|"/"[^*\n])*("/"?)\n	{
                         yyerror("indented code found outside of action\n");
			}; 
<LRRE>"["([^\\\]\n]|(\\([ntvbrfa\\?]|([0-7]{1,3}))))+"]" lexemeOut(outL); 
<LRRE>.                charOut(*yytext,outL);     
<LRA>\/\*              eatCommentAndEcho(outL); 
<LRA>\\\/              lexemeOut(outL);  
<LRA>\"                eatStringAndEcho(outL); 
<LRA>\\\"              lexemeOut(outL);  
<LRA>\{                {charOut('{',outL); nLbraces++;};
<LRA>\}                {charOut('}',outL); nLbraces--;}; 
<LRA>'\{'              lexemeOut(outL);   
<LRA>'\}'              lexemeOut(outL);  
<LRA>.                 charOut(*yytext,outL);  
<LRA>\n                {charOut('\n',outL); if (nLbraces == 0) BEGIN LRRE;}; 
<LRA>return            {charOut('{',outL); 
                        lexemeOut(LA1); 
                        BEGIN LRAAR; return(RETURN);
                       }; 
<LRAAR>\/\*            eatCommentAndEcho(LA1); 
<LRAAR>{OPTWS}         lexemeOut(LA1); 
<LRAAR>\(              {charOut('(',LA1); return('(');}; 
<LRAAR>\)              {charOut(')',LA1); return(')');}; 
<LRAAR>{GS}            {int symTabInd; 
                        lexemeOut(LA1); 
                        if (((IDbuffer = stringLookup(yytext,yyleng,0)) 
                             == 
                             ((char *)NULL)
                            )
                            || 
                            ((symTabInd = gSymLookup(IDbuffer)) == -1)  
                            || 
                            (gSymTable[symTabInd].symNum < 1)  
                           ) 
                           yyerror("return of other than a known token\n");  
                           else 
                           return(ID);  
                       }; 
<LRAAR>@\{             {BEGIN LRAAD; return(LBRACE);};   
<LRAAR>;               {charOut(';',LA1); charOut('}',LA1); return(';');}; 
<LRAAR>\n              {if (nLbraces == 0) 
                           {flushLAbuffer(LA1,outL); 
                            unput(*yytext); 
                            BEGIN LRA;  
                           } 
                           else  
                           charOut('\n',LA1); 
                       }; 
<LRAAR>.               {flushLAbuffer(LA1,outL); 
                        unput(*yytext); 
                        BEGIN LRA;  
                       }; 
<LRAAD>@\}             {flushLAbuffer(LA1,outL);BEGIN LRA;return(RBRACE);};   
<LRAAD>@               BEGIN LRAAD1; 
<LRAAD1>@              BEGIN LRAAD; 
<LRAAD1>{ATTRB_NAME}   {scanAttrbName(); transAttrbNameToNumPair(); 
                        return(ID); 
                       };     
<LRAAD1>.              {unput(*yytext); 
                        yyerror("attribute reference not terminated by @.\n"); 
	                BEGIN LRA;
		       }; 
<LRAAD>.               charOut(*yytext,outL); 
<LUS>\n|.              charOut(*yytext,outL);   
%%   
int yywrap(void){return 1;}

/**  are start conditions 
  * related to scanning and parsing the syntactic specification (the yacc-
  * like part) of yox's input.  Start conditions are here referred to also 
  * as "states".    
  * 
  * YDSI is used to intercept the lexeme of the start symbol for the purpose 
  * of augmenting the grammar. 
  *  
  * YR1 is used for looking ahead after seeing an identifier to see if it is 
  * followed by a colon.    
  * 
  * ADSL is separate from SS to avoid echoing the grammar symbols that 
  * appear in attribute declaration sections.  In state SS, when a closing 
  * curly brace is seen, it is at the end of an attribute declaration list.  
  * The only other such braces are seen at the ends of actions or unions, 
  * but these are seen in state AA or UU.  
  *  
  * AA is used for copying a yacc action.  The main idea is to keep echoing 
  * until the opening curly brace is paired.  Curly braces in strings, 
  * comments, and character constants are ignored.   
  * 
  * After the closing curly brace is detected in state AA, it has to be 
  * decided whether the action just scanned is the last thing (grammar 
  * symbol, action, or precedence) other than an attribute definitions 
  * section,  
  * vertical bar, or semicolon, in the current rulebody (RHS).  If it is 
  * the last thing, then some code that generates a parse tree node upon 
  * reduction by the present production has to be inserted before printing the 
  * closing brace of the action.  Note that yacc doesn't permit two 
  * adjacent actions in a given rulebody.  If it isn't the last thing, 
  * then the generation of such code will appear in a later action.  If 
  * the last thing in a rulebody isn't an action, then a left curly brace, 
  * the node-generating code, and a right curly brace will be generated,  
  * while everything else is echoed.  An action could be followed by 
  * whitespace, comments, and identifier, more whitespace and comments, 
  * and finally by a colon, and it can't be known until the colon is seen 
  * that the action was the last thing in the rulebody.  So it all has to 
  * be buffered.  This is the purpose of the LAAA (lookahead after action) 
  * and LAAA1 states, and of the lookahead buffer array and file and 
  * their associated routines, LAAA1 is analogous to SS1.  
  *  
  * UU is for echoing unions.  Its curly-brace-balancing strategy 
  * is similar to that of AA.  
  * 
  * CC is for echoing sections of C code between "%{" and "%}". 
  * 
  * TT is for echoing the tail section. 
  *  
  * RR is for echoing the root reference section.  RR1 is for splitting 
  * dollars signs away from attribute names to make them easier to 
  * handle.  The appropriate C reference to a C variable is substituted 
  * for the attribute name.    
  *  
  * DL is for reading attribute dependencies (explicit, mixed, implicit). 
  * 
  * CL is entered upon leaving DL.  CL is for reading attribute reference 
  * sections.  CL1 is analogous to RR1. The appropriate C reference to a 
  * C variable is substituted for the attribute name.  CL2 is used 
  * for consumption of backslashes and ease of echoing when a backslash 
  * continuation of an attribute reference section is encountered.   
  *  
*/ 


/* EOGFRET becomes the start condition upon the first execution of yywrap(). 
 * Its only purpose is to cause the scanner to return a token to signify 
 * to the parser that the end of the file containing the syntactic 
 * specification has been encountered.  
*/ 
 

 
/* LD LRP LRRE LRRE1 LRA LRA1 LRAR LUS are start conditions of the scanner 
 * that pertain to scanning and parsing the lexical specification (which 
 * is written in a lex-like syntax).  The main problem is for the scanner 
 * to know when it is looking at a lex action, and to look out for 
 * dollars signs inside such actions, and to ignore dollars signs elsewhere.   
 *  
 * LD is for echoing the lex definitions section.  
 * 
 * LRP is for echoing the prolog of the lex rules section.   
 * 
 * LRRE is for echoing and detecting the ends of lex regular expressions. 
 * lex r.e.'s are terminated and lex actions are initiated by whitespace.  
 *
 * LRRE1 is for echoing C code sections, indented and delimited by "%{" and 
 * "%}".   
 * 
 * LRA is for looking for attribute references inside of actions in the lex 
 * rules section, and for looking for the ends of such actions.  A lex action 
 * is terminated by the first newline outside of properly paired curly 
 * braces.  LRA1 is for stripping dollars signs from attribute references, 
 * thereby leaving attribute names.  
 * 
 * LRAR is for finding the name of the first grammar symbol seen   
 * after the "return" reserved word in a lex action.  
 *  
 * LUS is for echoing the optional user subroutines section found after 
 * the second "%%" in the lexical specification.   
 *
 * LKLDG means lex kludge.  It is used to match "%%" at the beginning of the 
 * file rather than just at beginning of line.  
*/  



