#include "yyltype.hh"

/* used by lexer */
extern void      eat_comment(const char *end,int *yycolno,int *yylineno);
extern symbolP   addYaccSymbolIfNew(YYLTYPE *,char *);
extern void      dumpYaccSymbolTable(void);
extern char     *addOxSymbolIfNew(symTable,YYLTYPE *,char *);
extern void      dumpOxSymbolTable(void);
extern bool      cmpYaccToOxSymbolTable(void);

/* used by parser */

#define YYERROR_DETAILED
extern void	 yyerror_detailed(const char *,int,YYSTYPE,YYLTYPE);

extern symTable  g_SymbolTable(void);
extern void      newConst(YYLTYPE,symbolP,int);
extern symbolP   newOxConst(symTable,YYLTYPE,char *,int);
extern YYLTYPE   locSpan(YYLTYPE,YYLTYPE);
extern int       valOf(YYLTYPE,symbolP);
extern int       oxValOf(symTable,YYLTYPE,char *);
extern void      newType(YYLTYPE,symbolP,typeSpecP);
extern symbolP   newOxType(symTable,YYLTYPE,char *,typeSpecP);
extern typeSpecP makeEnumType(YYLTYPE,enumListP);
extern typeSpecP makeSubrangeType(YYLTYPE,int,int);
extern typeSpecP typeOf(YYLTYPE,symbolP);
extern typeSpecP oxTypeOf(symTable,YYLTYPE,char *);
extern enumListP newEnum(YYLTYPE,symbolP);
extern enumListP newOxEnum(symTable,YYLTYPE,char *);
extern enumListP addToEnum(YYLTYPE,enumListP,symbolP);
extern enumListP addToOxEnum(symTable,YYLTYPE,enumListP,char *);
