/* $Id: sem.h 648 2018-01-17 22:16:43Z Tom Shields $ */ 

#define FIRSTREGNUM 0

extern void semSetup(void);
extern struct dim *consDimList(long,struct dim *,lineNumType); 
extern struct sym *concatLocs(struct sym *,struct sym *); 
extern struct dim *cdrDimList(struct dim *,struct sym*,lineNumType); 
extern struct dim *adjustDimList(struct sym *,struct sym *,lineNumType); 
extern struct sym *cdrParamList(struct sym *,struct sym *,lineNumType);
extern void paramMatchCheck(struct sym *,
                            enum symType,
                            enum pred,
                            enum pred,
                            struct sym *,
                            lineNumType);
extern struct sym *newStgSym(char *,
                             lineNumType,
                             enum symType,
                             enum stgClass,
                             struct dim *);
extern struct sym *newFuncSym(char *,
                              lineNumType,
                              enum symType,
                              labelType,
                              struct sym *);
extern struct env *newEnv(struct env *,
                          struct sym *,
                          struct sym *,
                          struct sym *,
                          regNumType); 
extern struct sym *stgRefLookup(struct env *,char *,lineNumType);
extern struct sym *funcInvocLookup(struct env *,char *,lineNumType);
extern enum symType binOpTypeCheck(enum symType,
                                   enum symType,
                                   int,
                                   lineNumType); 
extern enum symType unrOpTypeCheck(enum symType,int,lineNumType); 
extern enum symType assignmentTypeCheck(enum symType,
                                        enum symType,
                                        lineNumType); 

